
; ========================================================
;			
;    -- DirectSoundTest.asm --
;			Jay Sullivan
; ========================================================
  

.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     Includes
	;----------------------------
		
		include DirectSoundTest.inc
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
		WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
		CoCreateDS PROTO freq:DWORD
		WriteSoundToBuffer PROTO pBlock1:DWORD, sizeBlock1:DWORD, pBlock2:DWORD, sizeBlock2:DWORD, freq:DWORD
		
;------------------------------------------------
;                .CODE
;------------------------------------------------

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke GetProcessHeap
		mov hHeap,eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND



	;------------------------------------------------
	;	Windows
	;------------------------------------------------
			
		;------------------------------------------------
		;	Main Window Register
		;------------------------------------------------
		
			mov wc.cbSize, Sizeof WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW
			mov wc.lpfnWndProc, Offset WndProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,NULL
			mov eax,hInst
			mov wc.hInstance,eax
			mov wc.hbrBackground, COLOR_WINDOW+1
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset ClassName
			invoke LoadIcon, NULL, IDI_APPLICATION
			mov wc.hIcon,eax
			mov wc.hIconSm,0
			invoke LoadCursor, NULL, IDC_ARROW
			mov wc.hCursor,eax
			invoke RegisterClassEx, ADDR wc
		
		
		;------------------------------------------------
		;	Main Window Create
		;------------------------------------------------
		
				
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
				WS_OVERLAPPEDWINDOW,\
				CW_USEDEFAULT,CW_USEDEFAULT,230,180,\
				NULL,NULL,hInst,NULL
			mov hwnd,eax
			mov hMainWindow, eax
		;------------------------------------------------
		;	myButton1 Create
		;------------------------------------------------
		
			
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("220.0"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,0,0,120,35,hwnd,0,hInst,0
			mov myButton220,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("440.0"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,0,35,120,35,hwnd,0,hInst,0
			mov myButton440,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("660.0"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,0,70,120,35,hwnd,0,hInst,0
			mov myButton660,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("880.0"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,0,105,120,35,hwnd,0,hInst,0
			mov myButton880,eax



	;------------------------------------------------
	;	WinMain Code
	;------------------------------------------------
			
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP


;------------------------------------------------
;	WndProc
;------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	;-----------------------------
	 .if uMsg==WM_CREATE
	;-----------------------------
	
		invoke CoInitialize, NULL
		
	    ;-----------------------------------------------------------------
	    ;  Get a pointer to the IDirectSound8 interface. 
	    ;-----------------------------------------------------------------
    		mov pIDirectSound, 0
		    invoke CoCreateInstance, ADDR CLSID_IDirectSound8, NULL, CLSCTX_INPROC_SERVER, 
		                             ADDR IID_IDirectSound8,
		                             ADDR pIDirectSound
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("CoCreateInstance"), $String("Failed"), MB_OK or MB_ICONERROR
		    	invoke PostMessage,hWnd, WM_DESTROY, 0,0
		    	jmp CreateFail
		    .endif
		    
	    ;-----------------------------------------------------------------
	    ;  IDirectSound8::Initialize
	    ;-----------------------------------------------------------------
	      	coinvoke pIDirectSound, IDirectSound8, Initialize, NULL
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSound8::Initialize"), $String("Failed"), MB_OK or MB_ICONERROR
		    	invoke PostMessage,hWnd, WM_DESTROY, 0,0
		    	jmp CreateFail
		    .endif
		    
	    ;-----------------------------------------------------------------
	    ;  IDirectSound8::SetCooperativeLevel
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSound, IDirectSound8, SetCooperativeLevel,\
            		 hWnd, \
            		 1  ; 1 = DSSCL_NORMAL
            		 	; 2= DSSCL_PRIORITY 
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSound8::SetCooperativeLevel"), $String("Failed"), MB_OK or MB_ICONERROR
		    	invoke PostMessage,hWnd, WM_DESTROY, 0,0
		    	jmp CreateFail
		    .endif
		    
		    CreateFail:
		    
	;-----------------------------
	 .elseif uMsg==WM_DESTROY
	;-----------------------------
	
	
		.if pIDirectSound != 0
		    ;-----------------------------------------------------------------
		    ;  IDirectSound8::Release
		    ;-----------------------------------------------------------------
		     coinvoke pIDirectSound, IDirectSound8, Release
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSound8::Release"), $String("Failed"), MB_OK or MB_ICONERROR
		    .endif
		.endif
		
		invoke CoUninitialize
		invoke PostQuitMessage, NULL
		
	;-----------------------------
	 .elseif uMsg==WM_COMMAND
	;-----------------------------
		
		mov eax,wParam
		;-----------------------------
		 .if ax== BN_CLICKED
		;-----------------------------
		
			mov eax, lParam
			.if eax==myButton220
			    invoke CoCreateDS, 220
			.elseif eax==myButton440
			    invoke CoCreateDS, 440
			.elseif eax==myButton660
			    invoke CoCreateDS, 660
			.elseif eax==myButton880
			    invoke CoCreateDS, 880
			.endif

		;-----------------------------
		 .endif
		;-----------------------------
		
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP

;---------------------------------------------------------------------
CoCreateDS PROC freq:DWORD
    LOCAL   pIDirectSoundBuffer:DWORD
    LOCAL   pIDirectSoundNotify:DWORD
    
    LOCAL pBufferStart:DWORD,  ; [out]
    	  outBufferSize:DWORD ; [out]
    LOCAL pBufferStart2:DWORD,  ; [out]
    	  outBufferSize2:DWORD ; [out]
    	  
    	  
    	  
    	  
    ;-----------------------------------------------------------------
    ;  Zero the interface pointers
    ;----------------------------------------------------------------
    
    	mov pIDirectSoundBuffer, 0
		    

	    ;-----------------------------------------------------------------
	    ;  IDirectSound8::CreateSoundBuffer
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSound, IDirectSound8, CreateSoundBuffer,\
            		 Offset myDSBufferDesc,\
            		 ADDR pIDirectSoundBuffer,\
            		 NULL
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSound8::CreateSoundBuffer"), $String("Failed"), MB_OK or MB_ICONERROR
		    	jmp ErrorDelete
		    .endif
		    
		    
	    ;-----------------------------------------------------------------
	    ;  IDirectSoundBuffer8::Lock
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSoundBuffer, IDirectSoundBuffer8, Lock, \
             	0,\    ; dwWriteCursor:DWORD,
                88200,\ ; dwWriteBytes:DWORD, 
                ADDR pBufferStart,\
                ADDR outBufferSize,\
                ADDR pBufferStart2,\ 
                ADDR outBufferSize2,\ 
                0 ; dwFlags:DWORD
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Lock"), $String("Failed"), MB_OK or MB_ICONERROR
		    	jmp ErrorDelete
		    .endif
		    
		    
	    
	    ;-----------------------------------------------------------------
	    ;  Write to buffer
	    ;-----------------------------------------------------------------
			invoke WriteSoundToBuffer,pBufferStart,outBufferSize, pBufferStart2,outBufferSize2, freq

		    
		    
		    
	    
	    ;-----------------------------------------------------------------
	    ;  IDirectSoundBuffer8::Unlock
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSoundBuffer, IDirectSoundBuffer8, Unlock, \
                pBufferStart,\
                outBufferSize,\
                pBufferStart2,\ 
                outBufferSize2
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Unlock"), $String("Failed"), MB_OK or MB_ICONERROR
		    	jmp ErrorDelete
		    .endif
		   
	    ;-----------------------------------------------------------------
	    ;  IDirectSoundBuffer8::Play
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSoundBuffer, IDirectSoundBuffer8, Play, \
                0,\
                0,\
                DSBPLAY_LOOPING
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Play"), $String("Failed"), MB_OK or MB_ICONERROR
		    	jmp ErrorDelete
		    .else
				invoke MessageBox, hMainWindow, $String("IDirectSound8::Play"), $String("Playing!"), MB_OK or MB_USERICON
		    .endif
		    
	
 
 	    ;-----------------------------------------------------------------
	    ;  IDirectSound8::Stop
	    ;-----------------------------------------------------------------
	     coinvoke pIDirectSoundBuffer, IDirectSoundBuffer8, Stop
	     .if eax!=0
	    	invoke MessageBox, hMainWindow, $String("IDirectSound8::Stop"), $String("Failed"), MB_OK or MB_ICONERROR
	    	jmp ErrorDelete
	     .endif
	    
	    
	    
       ErrorDelete:
       
		.if pIDirectSoundBuffer != 0
		    ;-----------------------------------------------------------------
		    ;  IDirectSoundBuffer8::Release
		    ;-----------------------------------------------------------------
		     coinvoke pIDirectSoundBuffer, IDirectSoundBuffer8, Release
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Release"), $String("Failed"), MB_OK or MB_ICONERROR
		    .endif
		.endif

    ret
CoCreateDS ENDP
;---------------------------------------------------------------------


WriteSoundToBuffer PROC pBlock1:DWORD, sizeBlock1:DWORD, pBlock2:DWORD, sizeBlock2:DWORD, freq:DWORD
LOCAL index:DWORD, outcalc:DWORD,
      sinmulti:REAL8
      
      
	  ;-----------------------------------------------------------------
      ; 44100 sps @  2 bytes per sample  
      ; = 88200 bytes per second
	  ;-----------------------------------------------------------------
	  ; a sine wave with frequency F hertz will be of wavelength
	  ; 88200/F  bytes
	  ;-----------------------------------------------------------------
	  ;- value of sample[n] = sin(2 * pi * 88200 /  F / n) ) * amplitude
	  ;-----------------------------------------------------------------
      
		    ;-----------------------------------------------------------------
		    ;  Load up "sinmulti"
		    ;-----------------------------------------------------------------
			fldpi
			fimul freq 
			fidiv $Const(88200); (x2) ? channels
			fstp sinmulti
				
			 
		    ;-----------------------------------------------------------------
		    ;  Write sample[n] sound to buffer        
		    ;-----------------------------------------------------------------
		     mov eax, pBlock1
		     mov ecx, sizeBlock1
			 mov index, 0
		     mov edx, 0
		     .while ecx>0
		     	
		     	fld sinmulti
		     	fimul index
		     	fsin
		     	fimul $Const(32767)
		     	fistp word ptr [eax+edx]
		     	
		     	add index, 1
		     	add edx, 2
		     	sub ecx, 2
		     .endw
		     
		     
	ret
WriteSoundToBuffer ENDP


End Start


